# Python 3.6+
# Django Web Framework referans alınarak hazırlanmıştır
# Ara Bildirim URL için örnek kodlar

import base64
import hashlib
import hmac
import json

from django.shortcuts import render, HttpResponse
from django.views.decorators.csrf import csrf_exempt

@csrf_exempt
def callback(request):
    if request.method != 'POST':
        return HttpResponse(str(''))

    post = request.POST

    # API Entegrasyon Bilgileri - Mağaza paneline giriş yaparak BİLGİ sayfasından alabilirsiniz.
    merchant_key = b'XXXXXXXXXXXXXXXX'
    merchant_salt = 'XXXXXXXXXXXXXXXX'

    # Bu kısımda herhangi bir değişiklik yapmanıza gerek yoktur.
    # POST değerleri ile hash oluştur.
    hash_str = post['merchant_oid'] + post['bank'] + merchant_salt
    hash = base64.b64encode(hmac.new(merchant_key, hash_str.encode(), hashlib.sha256).digest())

    # Oluşturulan hash'i, paytr'dan gelen post içindeki hash ile karşılaştır
    # (isteğin paytr'dan geldiğine ve değişmediğine emin olmak için)
    # Bu işlemi yapmazsanız maddi zarara uğramanız olasıdır.
    if hash != post['hash']:
        return HttpResponse(str('PAYTR notification failed: bad hash'))

    """
    DÖNÜLEN POST DEĞERLERİ
    
    post['merchant_oid']      => Sipariş Numarası
    post['status']            => "info"
    post['hash']              => PayTR Tarafından Hesaplanan Hash Değe
    
    # AŞAĞIDAKİLER MÜŞTERİNİN FORMA GİRDİĞİ BİLGİLERDİR #
    
    post['payment_sent_date'] => Ödeme Yapılan Tarih
    post['bank']              => Ödeme Yapılan Banka
    post['user_name']         => Ödeme Yapan Adı Soyadı
    post['user_phone']        => Ödeme Yapan Telefon Numarası
    post['tc_no_last5']       => T.C. Kimlik Numarası Son 5 Hanesi
    
    """
    return HttpResponse(str('OK'))